import _extends from "@babel/runtime/helpers/esm/extends";
import { forwardRef } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import AtomLabel from '@s-ui/react-atom-label';
import { TYPES } from '../config.js';
import { suitClass, switchClassNames } from './helpers.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var ToggleSwitchTypeRender = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _cx, _cx2;

  var disabled = _ref.disabled,
      isFitted = _ref.isFitted,
      isToggle = _ref.isToggle,
      label = _ref.label,
      labelLeft = _ref.labelLeft,
      iconLeft = _ref.iconLeft,
      iconRight = _ref.iconRight,
      labelOptionalText = _ref.labelOptionalText,
      labelRight = _ref.labelRight,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onToggle = _ref.onToggle,
      size = _ref.size,
      type = _ref.type,
      value = _ref.value,
      fullWidth = _ref.fullWidth,
      isChecked = _ref.isChecked;
  return /*#__PURE__*/_jsxs("div", {
    className: switchClassNames({
      size: size,
      classType: 'toggleType',
      fullWidth: fullWidth
    }),
    children: [label && /*#__PURE__*/_jsx(AtomLabel, {
      name: name,
      text: label,
      optionalText: labelOptionalText
    }), /*#__PURE__*/_jsxs("div", {
      className: cx(suitClass({
        element: 'container'
      }), (_cx = {}, _cx[suitClass({
        element: 'container--isFitted'
      })] = isFitted, _cx[suitClass({
        element: 'container--fullWidth'
      })] = fullWidth, _cx)),
      onFocus: onFocus,
      onBlur: onBlur,
      ref: ref,
      children: [/*#__PURE__*/_jsx("span", {
        className: cx(suitClass({
          element: 'text'
        }), suitClass({
          element: 'left'
        })),
        onClick: onToggle(false),
        "aria-disabled": disabled,
        children: labelLeft
      }), /*#__PURE__*/_jsxs("button", _extends({
        type: "button",
        className: cx(suitClass({
          element: 'inputContainer'
        }), (_cx2 = {}, _cx2[suitClass({
          element: 'inputContainer',
          modifier: 'right'
        })] = isChecked, _cx2)),
        role: "switch",
        "aria-checked": isChecked || type === TYPES.SELECT,
        "aria-disabled": disabled,
        disabled: disabled
      }, !disabled && {
        tabIndex: 0
      }, {
        onClick: onToggle(),
        children: [/*#__PURE__*/_jsx("div", {
          className: cx(suitClass({
            element: 'icon-left'
          })),
          children: iconLeft
        }), /*#__PURE__*/_jsx("div", {
          className: cx(suitClass({
            element: 'circle'
          }))
        }), /*#__PURE__*/_jsx("div", {
          className: cx(suitClass({
            element: 'icon-right'
          })),
          children: iconRight
        })]
      })), /*#__PURE__*/_jsx("span", {
        className: cx(suitClass({
          element: 'text'
        }), suitClass({
          element: 'right'
        })),
        onClick: onToggle(true),
        "aria-disabled": disabled,
        children: labelRight
      })]
    })]
  });
});
ToggleSwitchTypeRender.displayName = 'ToggleSwitchTypeRender';